<template>
  <v-list-item
    icon
    dense
    @click="() => uploader.click()"
  >
    <v-list-item-icon><v-icon>mdi-upload</v-icon></v-list-item-icon>
    <v-list-item-title id="import-button">
      {{ $t('button.import') }}
    </v-list-item-title>
    <input
      ref="uploader"
      aria-labelledby="import-button"
      class="d-none"
      type="file"
      accept=".dez"
      hidden
      @change="load"
    >
  </v-list-item>
</template>

<script lang="ts">
import {
  Vue, Component, Ref,
} from 'vue-property-decorator';
import AnalysisParser from '@/formats/AnalysisParser';
import type { Analysis } from '@/data';
import { warnAnalysisParsing } from '@/components/dialogs';

@Component({})
export default class ImportButton extends Vue {
  @Ref()
  uploader!: HTMLInputElement;

  async load() {
    const file = this.uploader?.files?.[0];

    if (!file) return;

    this.uploader.value = '';

    try {
      const parsed = JSON.parse(await file.text());
      const analysis: Analysis = AnalysisParser.parseFormat(parsed, file.name);
      this.$emit('replace-analysis', analysis);
    } catch (e) {
      // eslint-disable-next-line no-console
      console.error('Could not import:', e);
      warnAnalysisParsing(file.name);
    }
  }
}
</script>
